=== modified file '.bzrignore'
--- .bzrignore	2010-04-22 08:52:59 +0000
+++ .bzrignore	2010-03-23 15:44:51 +0000
@@ -7,5 +7,5 @@
 *.log
 _trial_temp
 loggerhead-memprofile
-./docs/_build/
-tags
+docs/_build/doctrees
+docs/_build/html

=== modified file 'NEWS'
--- NEWS	2011-02-10 17:01:10 +0000
+++ NEWS	2010-02-26 04:38:23 +0000
@@ -1,26 +1,8 @@
 What's changed in loggerhead?
 =============================
 
-1.19 [???]
-----------------
-
-    - If we get a HEAD request, there is no reason to expand the template, we
-      shouldn't be returning body content anyway.
-      (John Arbash Meinel, #716201, #716217)
-
-    - Merge the pqm changes back into trunk, after trunk was reverted to an old
-      revision. (John Arbash Meinel, #716152)
-
-
-1.18 [10Nov2010]
-----------------
-
-    - Syntax highlighting is no longer applied for files greater than 512K,
-      reducing codebrowse.launchpad.net overloading.
-      (Max Kanat-Alexander, #513044)
-
-    - Documentation added in the docs directory. README simplified
-      accordingly. (Tres Seaver).
+dev [future]
+------------
 
     - Show svn/git/hg revision ids in loggerhead revision view.
       (Jelmer Vernooij)
@@ -33,21 +15,8 @@
     - Repository.get_revision_inventory() was removed in bzr 2.2; use
       Repository.get_inventory() instead. (Matt Nordhoff, #528194)
 
-    - Ignore readonly+ prefix when checking if Loggerhead is serving a
-      local location. (Reported by Tres Seaver.) (Matt Nordhoff)
-
-    - Set Cache-Control and Expires headers on static pages.
-      (John Arbash Meinel)
-
-    - Generate relative links where possible (everywhere but HTTP
-      redirects and feed IDs). (Michael Hudson, Matt Nordhoff)
-
-    - Fix bad redirect when visiting "/download" or "/download/".
-      (Matt Nordhoff, #247992)
-
-
 1.17 [20Aug2009]
-----------------
+---------------
 
     - Add bug links in revision informations (Alexandre Garnier, #314052)
 
@@ -151,7 +120,7 @@
 
     - Fix a file descriptor leak (Matt Nordhoff, #370845)
 
-    - Use transport API internally, so it is possible to specify a remote
+    - Use transport API internally, so it is possible to specify a remote 
       URL to serve-branches. (Jelmer Vernooij, #371787)
 
     - Fix internal server errors when using start-loggerhead. (Matt
@@ -200,7 +169,7 @@
 
 
 1.10 [22Dec2008]
-----------------
+---------------
 
     - Add startup deamon script for Linux (Marius Kruger)
 

=== modified file 'README'
--- README	2010-04-23 01:30:29 +0000
+++ README	2009-11-27 18:06:53 +0000
@@ -1,28 +1,127 @@
-Loggerhead
+LOGGERHEAD
 ==========
 
-Overview
---------
-
-Loggerhead is a web viewer for Bazaar branches. Its lets users do
-stuff like:
-
-* navigate through branch history
-* view the files in a given revision
-* annotate files (i.e. find out the origin of each line of a file)
-* perform searches.
-
-
-Documentation
--------------
-
-See docs/index.rst for installation instructions and basic
-documentation.
-
-
-Licensing
----------
-
-This software is (C) Copyright Canonical Limited 2006-10 under the
-GPL Version 2 or later. Please see the file COPYING.txt for the
-licence details.
+[ Version 1.17 for Bazaar 1.17 ]
+
+Loggerhead is a web viewer for Bazaar branches.  It can be used to
+navigate a branch history, annotate files, perform searches... all the
+usual things.
+
+
+GETTING STARTED
+---------------
+
+Loggerhead depends on:
+
+1) SimpleTAL for templating.
+   On Ubuntu, `sudo apt-get install python-simpletal`
+   or download from http://www.owlfish.com/software/simpleTAL/download.html
+2) simplejson for producing JSON data.
+   On Ubuntu, `sudo apt-get install python-simplejson`
+   or use `easy_install simplejson`.
+3) Paste for the server. (You need version 1.2 or newer of Paste.)
+   On Ubuntu, `sudo apt-get install python-paste`
+   or use `easy_install Paste`
+4) Paste Deploy  (optional, needed when proxying through Apache)
+   On Ubuntu, `sudo apt-get install python-pastedeploy`
+   or use `easy_install PasteDeploy`
+5) flup (optional, needed to use FastCGI, SCGI or AJP)
+   On Ubuntu, `sudo apt-get install python-flup`
+   or use `easy_install flup`
+
+Then simply run the 'serve-branches' with the branch you want to
+serve on the command line:
+
+    ./serve-branches ~/path/to/branch
+
+The script listens on port 8080 so head to http://localhost:8080/ in
+your browser to see the branch.  You can also pass a directory that
+contains branches to the script, and it will serve a very simple
+directory listing at other pages.
+
+You may update the Bazaar branches being viewed at any time.
+Loggerhead will notice and refresh, and Bazaar uses its own branch
+locking to prevent corruption.
+
+To run loggerhead as a linux daemon:
+1) Copy loggerheadd to /etc/init.d
+2) Edit the file to configure where your loggerhead is installed, and which
+   serve-branches options you would like.
+3) Register the service
+   cd /etc/init.d
+   a) on upstart based systems like Ubuntu run: 
+      update-rc.d loggerheadd defaults
+   b) on Sysvinit based systems like Centos or SuSE run:
+      chkconfig --add loggerheadd
+
+
+LOGGERHEAD AS A BAZAAR PLUGIN
+-----------------------------
+
+This branch contains experimental support for using Loggerhead as a Bazaar
+plugin.  To use it, place the top-level Loggerhead directory (the one
+containing this file) at ``~/.bazaar/plugins/loggerhead``.
+
+
+USING A CONFIG FILE
+-------------------
+
+To hide branches from being displayed, add to ``~/.bazaar/locations.conf``,
+under the branch's section:
+
+    [/path/to/branch]
+    http_serve = False
+
+
+More configuration options to come soon.
+
+
+SERVING LOGGERHEAD FROM BEHIND APACHE
+-------------------------------------
+
+If you want to view Bazaar branches from your existing Apache
+installation, you'll need to configure Apache to proxy certain
+requests to Loggerhead.  Adding lines like this to you Apache
+configuration is one way to do this::
+
+    <Location "/branches/">
+        ProxyPass http://127.0.0.1:8080/branches/
+        ProxyPassReverse http://127.0.0.1:8080/branches/
+    </Location>
+
+If Paste Deploy is installed, the 'serve-branches' script can be
+run behind a proxy at the root of a site, but if you're running it at
+some path into the site, you'll need to specify is using '--prefix=/some_path'.
+
+
+SEARCH
+------
+
+Search is currently supported by using the bzr-search plugin (available
+at: ``https://launchpad.net/bzr-search``
+You need to have the plugin installed and each branch indexed to allow
+searching on branches.
+
+
+SUPPORT
+-------
+
+Loggerhead is loosely based on bazaar-webserve, which was loosely
+based on hgweb.  Discussion should take place on the bazaar-dev
+mailing list at bazaar@lists.canonical.com.  You can join the list at
+<https://lists.ubuntu.com/mailman/listinfo/bazaar>.  You don't need to
+subscribe to post, but your first post will be held briefly for manual
+moderation.
+
+Bugs are tracked on Launchpad; start at:
+
+    https://bugs.launchpad.net/loggerhead
+
+
+HACKING
+-------
+
+To run loggerhead tests, you will need the package python-nose,
+and run in the loggerhead directory:
+
+    nosetests

=== modified file '__init__.py'
--- __init__.py	2011-02-10 01:57:32 +0000
+++ __init__.py	2009-10-17 06:35:33 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009, 2010, 2011 Canonical Ltd
+# Copyright 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -26,56 +26,50 @@
 
 """Loggerhead web viewer for Bazaar branches.
 
-This provides a new option "--http" to the "bzr serve" command, that
+This provides a new option "--http" to the "bzr serve" command, that 
 starts a web server to browse the contents of a branch.
 """
 
-from info import (
-    bzr_plugin_version as version_info,
-    bzr_compatible_versions,
-    )
+version_info = (1, 17, 0)
 
 if __name__ == 'bzrlib.plugins.loggerhead':
     import bzrlib
     from bzrlib.api import require_any_api
-    from bzrlib import commands
-
-    require_any_api(bzrlib, bzr_compatible_versions)
-
-    from bzrlib.transport import transport_server_registry
+
+    require_any_api(bzrlib, [
+        (1, 13, 0), (1, 15, 0), (1, 16, 0), (1, 17, 0), (1, 18, 0),
+        (2, 0, 0), (2, 1, 0)])
+
+    # NB: Normally plugins should lazily load almost everything, but this
+    # seems reasonable to have in-line here: bzrlib.commands and options are
+    # normally loaded, and the rest of loggerhead won't be loaded until serve
+    # --http is run.
+
+    # transport_server_registry was added in bzr 1.16. When we drop support for
+    # older releases, we can remove the code to override cmd_serve.
+
+    try:
+        from bzrlib.transport import transport_server_registry
+    except ImportError:
+        transport_server_registry = None
 
     DEFAULT_HOST = '0.0.0.0'
     DEFAULT_PORT = 8080
     HELP = ('Loggerhead, a web-based code viewer and server. (default port: %d)' %
             (DEFAULT_PORT,))
 
-    def setup_logging(config):
-        import logging
-        import sys
-
-        logger = logging.getLogger('loggerhead')
-        handler = logging.StreamHandler(sys.stderr)
-        handler.setLevel(logging.DEBUG)
-        logger.addHandler(handler)
-        logging.getLogger('simpleTAL').addHandler(handler)
-        logging.getLogger('simpleTALES').addHandler(handler)
-
-    def _ensure_loggerhead_path():
-        """Ensure that you can 'import loggerhead' and get the root."""
+    def serve_http(transport, host=None, port=None, inet=None):
+        from paste.httpexceptions import HTTPExceptionHandler
+        from paste.httpserver import serve
+
         # loggerhead internal code will try to 'import loggerhead', so
         # let's put it on the path if we can't find it in the existing path
         try:
-            import loggerhead.apps.transport
+            import loggerhead
         except ImportError:
             import os.path, sys
             sys.path.append(os.path.dirname(__file__))
 
-    def serve_http(transport, host=None, port=None, inet=None):
-        from paste.httpexceptions import HTTPExceptionHandler
-        from paste.httpserver import serve
-
-        _ensure_loggerhead_path()
-
         from loggerhead.apps.transport import BranchesFromTransportRoot
         from loggerhead.config import LoggerheadConfig
 
@@ -87,35 +81,42 @@
         if not transport.is_readonly():
             argv.insert(0, '--allow-writes')
         config = LoggerheadConfig(argv)
-        setup_logging(config)
         app = BranchesFromTransportRoot(transport.base, config)
         app = HTTPExceptionHandler(app)
         serve(app, host=host, port=port)
 
-    transport_server_registry.register('http', serve_http, help=HELP)
-
-    class cmd_load_test_loggerhead(commands.Command):
-        """Run a load test against a live loggerhead instance.
-
-        Pass in the name of a script file to run. See loggerhead/load_test.py
-        for a description of the file format.
-        """
-
-        takes_args = ["filename"]
-
-        def run(self, filename):
-            from bzrlib.plugins.loggerhead.loggerhead import load_test
-            script = load_test.run_script(filename)
-            for thread_id in sorted(script._threads):
-                worker = script._threads[thread_id][0]
-                for url, success, time in worker.stats:
-                    self.outf.write(' %5.3fs %s %s\n'
-                                    % (time, str(success)[0], url))
-
-    commands.register_command(cmd_load_test_loggerhead)
-
-    def load_tests(standard_tests, module, loader):
-        _ensure_loggerhead_path()
-        standard_tests.addTests(loader.loadTestsFromModuleNames(
-            ['bzrlib.plugins.loggerhead.loggerhead.tests']))
-        return standard_tests
+    if transport_server_registry is not None:
+        transport_server_registry.register('http', serve_http, help=HELP)
+    else:
+        import bzrlib.builtins
+        from bzrlib.commands import get_cmd_object, register_command
+        from bzrlib.option import Option
+
+        _original_command = get_cmd_object('serve')
+
+        class cmd_serve(bzrlib.builtins.cmd_serve):
+            __doc__ = _original_command.__doc__
+
+            takes_options = _original_command.takes_options + [
+                Option('http', help=HELP)]
+
+            def run(self, *args, **kw):
+                if 'http' in kw:
+                    from bzrlib.transport import get_transport
+                    allow_writes = kw.get('allow_writes', False)
+                    path = kw.get('directory', '.')
+                    port = kw.get('port', DEFAULT_PORT)
+                    # port might be an int already...
+                    if isinstance(port, basestring) and ':' in port:
+                        host, port = port.split(':')
+                    else:
+                        host = DEFAULT_HOST
+                    if allow_writes:
+                        transport = get_transport(path)
+                    else:
+                        transport = get_transport('readonly+' + path)
+                    serve_http(transport, host, port)
+                else:
+                    super(cmd_serve, self).run(*args, **kw)
+
+        register_command(cmd_serve)

=== modified file 'docs/index.rst'
--- docs/index.rst	2010-04-13 08:46:25 +0000
+++ docs/index.rst	2010-03-25 10:28:03 +0000
@@ -1,7 +1,7 @@
 Loggerhead:  A web viewer for ``bzr`` branches
 ==============================================
 
-Loggerhead is a web viewer for projects in Bazaar. It can be used to navigate 
+Loggerhead is a web viewer for projects in bazaar. It can be used to navigate 
 a branch history, annotate files, view patches, perform searches, etc.
 Loggerhead is heavily based on `bazaar-webserve
 <https://launchpad.net/bzr-webserve>`_, which was, in turn, loosely
@@ -106,7 +106,7 @@
 
 This branch contains experimental support for using Loggerhead as a Bazaar
 plugin.  To use it, place the top-level Loggerhead directory (the one
-containing COPYING.txt) at ``~/.bazaar/plugins/loggerhead``.  E.g.:
+containing this file) at ``~/.bazaar/plugins/loggerhead``.  E.g.:
 
 .. code-block:: sh
 
@@ -134,7 +134,7 @@
 
 If you want to view Bazaar branches from your existing Apache
 installation, you'll need to configure Apache to proxy certain
-requests to Loggerhead.  Adding lines like this to your Apache
+requests to Loggerhead.  Adding lines like this to you Apache
 configuration is one way to do this:
 
 .. code-block:: apache
@@ -146,7 +146,7 @@
 
 If Paste Deploy is installed, the :command:`serve-branches` script can be
 run behind a proxy at the root of a site, but if you're running it at
-some path into the site, you'll need to specify it using
+some path into the site, you'll need to specify is using
 ``--prefix=/some_path``.
 
 
@@ -179,7 +179,7 @@
 subscribe to post, but your first post will be held briefly for manual
 moderation.
 
-Bugs, support questions and merge proposals are tracked on Launchpad, e.g:
+Bugs are tracked on Launchpad; start at:
 
     https://bugs.launchpad.net/loggerhead
 

=== removed file 'info.py'
--- info.py	2011-02-10 17:01:10 +0000
+++ info.py	1970-01-01 00:00:00 +0000
@@ -1,14 +0,0 @@
-#!/usr/bin/env python
-# API Info for loggerhead
-
-bzr_plugin_name = "loggerhead"
-
-bzr_plugin_version = (1, 18, 0)
-
-bzr_compatible_versions = [
-    (1, 17, 0), (1, 18, 0), (2, 0, 0), (2, 1, 0), (2, 2, 0), (2, 3, 0),
-    (2, 4, 0)]
-
-bzr_minimum_version = bzr_compatible_versions[0]
-
-bzr_maximum_version = bzr_compatible_versions[-1]

=== removed directory 'load_test_scripts'
=== removed file 'load_test_scripts/multiple_instances.script'
--- load_test_scripts/multiple_instances.script	2011-02-10 01:00:32 +0000
+++ load_test_scripts/multiple_instances.script	1970-01-01 00:00:00 +0000
@@ -1,19 +0,0 @@
-{
-    "comment": "Connect to multiple loggerhead instances and make requests on each. One should be on :8080, one should be on :8081. Multiple threads will place requests on each.",
-    "parameters": {"base_url": "http://localhost"},
-    "requests": [
-        {"thread": "1", "relpath": ":8080/changes"},
-        {"thread": "2", "relpath": ":8080/files"},
-        {"thread": "3", "relpath": ":8081/files"},
-        {"thread": "4", "relpath": ":8081/changes"},
-        {"thread": "1", "relpath": ":8080/changes"},
-        {"thread": "2", "relpath": ":8080/files"},
-        {"thread": "3", "relpath": ":8081/files"},
-        {"thread": "4", "relpath": ":8081/changes"},
-        {"thread": "1", "relpath": ":8080/changes"},
-        {"thread": "2", "relpath": ":8080/files"},
-        {"thread": "3", "relpath": ":8081/files"},
-        {"thread": "4", "relpath": ":8081/changes"}
-    ]
-}
-

=== removed file 'load_test_scripts/simple.script'
--- load_test_scripts/simple.script	2011-02-10 01:00:32 +0000
+++ load_test_scripts/simple.script	1970-01-01 00:00:00 +0000
@@ -1,9 +0,0 @@
-{
-    "comment": "A fairly trivial load test script. It just loads the main two pages from a loggerhead install running directly on a branch.",
-    "parameters": {"base_url": "http://localhost:8080"},
-    "requests": [
-        {"relpath": "/changes"},
-        {"relpath": "/files"}
-    ]
-}
-

=== modified file 'loggerhead.conf.example'
--- loggerhead.conf.example	2009-10-17 09:28:42 +0000
+++ loggerhead.conf.example	2008-07-22 00:40:03 +0000
@@ -23,7 +23,7 @@
 
     # name of this project
     name = 'bazaar'
-
+    
     # for the top browsing page, you can include a description, in raw HTML.
     #description = 'Bazaar is a <i>revision control system</i>.'
 
@@ -63,13 +63,13 @@
 [paramiko]
     name = 'paramiko'
     cachepath = '/Users/robey/code/paramiko/.bzr/loggerhead-files'
-
+    
     # if an auto_publish_folder is given, any bazaar branches discovered in
     # that folder will be published.  using each branch's 'branch.conf' to
     # provide optional descriptions and public urls is a nice way to avoid
     # having to do much configuration here.
     auto_publish_folder = '/Users/robey/code/paramiko'
-
+    
     # if all of the branches under an auto_publish_folder are exported to
     # the same (base) public url, you can specify that url prefix here, and
     # each discovered branch's public url will be generated.

=== modified file 'loggerhead/__init__.py'
--- loggerhead/__init__.py	2010-11-11 03:30:43 +0000
+++ loggerhead/__init__.py	2009-08-20 13:30:37 +0000
@@ -22,7 +22,7 @@
 
 import pkg_resources
 
-__version__ = '1.18'
+__version__ = '1.17'
 required_bzrlib = (1, 17)
 
 pkg_resources.get_distribution('Paste>=1.6')

=== modified file 'loggerhead/apps/__init__.py'
--- loggerhead/apps/__init__.py	2010-04-30 21:30:18 +0000
+++ loggerhead/apps/__init__.py	2009-11-26 03:44:40 +0000
@@ -9,9 +9,7 @@
 static = os.path.join(
     os.path.dirname(os.path.dirname(__file__)), 'static')
 
-# Static things can be cached for half a day, we could probably make this
-# longer, except for just before rollout times.
-static_app = urlparser.make_static(None, static, cache_max_age=12*60*60)
+static_app = urlparser.make_static(None, static)
 
 favicon_app = convert_file_errors(fileapp.FileApp(
     os.path.join(static, 'images', 'favicon.ico')))

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2011-02-09 22:29:57 +0000
+++ loggerhead/apps/branch.py	2009-10-17 06:35:33 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008-2011 Canonical Ltd.
+# Copyright (C) 2008, 2009 Canonical Ltd.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,7 +21,6 @@
 import sys
 
 import bzrlib.branch
-import bzrlib.errors
 import bzrlib.lru_cache
 
 from paste import request
@@ -29,7 +28,6 @@
 
 from loggerhead.apps import static_app
 from loggerhead.controllers.annotate_ui import AnnotateUI
-from loggerhead.controllers.view_ui import ViewUI
 from loggerhead.controllers.atom_ui import AtomUI
 from loggerhead.controllers.changelog_ui import ChangeLogUI
 from loggerhead.controllers.diff_ui import DiffUI
@@ -90,15 +88,10 @@
             if v is not None:
                 qs.append('%s=%s' % (k, urllib.quote(v)))
         qs = '&'.join(qs)
-        path_info = urllib.quote(
-            unicode('/'.join(args)).encode('utf-8'), safe='/~:')
-        if qs:
-            path_info += '?' + qs
-        return self._url_base + path_info
-
-    def absolute_url(self, *args, **kw):
-        rel_url = self.url(*args, **kw)
-        return request.resolve_relative_url(rel_url, self._environ)
+        return request.construct_url(
+            self._environ, script_name=self._url_base,
+            path_info=unicode('/'.join(args)).encode('utf-8'),
+            querystring=qs)
 
     def context_url(self, *args, **kw):
         kw = util.get_context(**kw)
@@ -125,7 +118,6 @@
         'files': InventoryUI,
         'revision': RevisionUI,
         'search': SearchUI,
-        'view': ViewUI,
         }
 
     def last_updated(self):
@@ -153,15 +145,14 @@
             else:
                 # Loggerhead only supports serving .bzr/ on local branches, so
                 # we shouldn't suggest something that won't work.
-                try:
-                    util.local_path_from_url(self.branch.base)
+                if self.branch.base.startswith('file://'):
                     self.served_url = self.url([])
-                except bzrlib.errors.InvalidURL:
+                else:
                     self.served_url = None
         path = request.path_info_pop(environ)
         if not path:
             raise httpexceptions.HTTPMovedPermanently(
-                self.absolute_url('/changes'))
+                self._url_base + '/changes')
         if path == 'static':
             return static_app(environ, start_response)
         cls = self.controllers_dict.get(path)

=== modified file 'loggerhead/apps/config.py'
--- loggerhead/apps/config.py	2010-05-05 18:35:35 +0000
+++ loggerhead/apps/config.py	2009-05-13 13:14:04 +0000
@@ -208,8 +208,8 @@
                                 environ['SCRIPT_NAME']
         segment = path_info_pop(environ)
         if segment is None:
-            raise httpexceptions.HTTPMovedPermanently.relative_redirect(
-                environ['SCRIPT_NAME'] + '/', environ)
+            raise httpexceptions.HTTPMovedPermanently(
+                environ['SCRIPT_NAME'] + '/')
         elif segment == '':
             response = WSGIResponse()
             self.browse(response)

=== modified file 'loggerhead/apps/transport.py'
--- loggerhead/apps/transport.py	2010-05-05 18:35:35 +0000
+++ loggerhead/apps/transport.py	2009-11-26 03:20:53 +0000
@@ -28,12 +28,10 @@
 from paste import httpexceptions
 from paste import urlparser
 
-from loggerhead import util
 from loggerhead.apps.branch import BranchWSGIApp
 from loggerhead.apps import favicon_app, robots_app, static_app
 from loggerhead.controllers.directory_ui import DirectoryUI
 
-# TODO: Use bzrlib.ui.bool_from_string(), added in bzr 1.18
 _bools = {
     'yes': True, 'no': False,
     'on': True, 'off': False,
@@ -69,8 +67,8 @@
     def app_for_non_branch(self, environ):
         segment = path_info_pop(environ)
         if segment is None:
-            raise httpexceptions.HTTPMovedPermanently.relative_redirect(
-                environ['SCRIPT_NAME'] + '/', environ)
+            raise httpexceptions.HTTPMovedPermanently(
+                environ['SCRIPT_NAME'] + '/')
         elif segment == '':
             if self.name:
                 name = self.name
@@ -95,8 +93,11 @@
             # TODO: Use something here that uses the transport API
             # rather than relying on the local filesystem API.
             base = self.transport.base
+            readonly_prefix = 'readonly+'
+            if base.startswith(readonly_prefix):
+                base = base[len(readonly_prefix):]
             try:
-                path = util.local_path_from_url(base)
+                path = urlutils.local_path_from_url(base)
             except errors.InvalidURL:
                 raise httpexceptions.HTTPNotFound()
             else:

=== modified file 'loggerhead/config.py'
--- loggerhead/config.py	2010-04-13 23:35:01 +0000
+++ loggerhead/config.py	2009-11-23 22:45:46 +0000
@@ -87,7 +87,7 @@
         self.SQL_DIR = sql_dir
 
     def get_option(self, option):
-        """Get the value for the config option, either
+        """Get the value for the config option, either 
         from ~/.bazaar/bazaar.conf or from the command line.
         All loggerhead-specific settings start with 'http_'
         """

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2011-02-10 17:01:10 +0000
+++ loggerhead/controllers/__init__.py	2009-10-17 08:59:33 +0000
@@ -17,10 +17,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import bzrlib.errors
 import time
 
-from paste.httpexceptions import HTTPNotFound
 from paste.request import path_info_pop, parse_querystring
 
 from loggerhead import util
@@ -99,9 +97,6 @@
         if 'Content-Type' not in headers:
             headers['Content-Type'] = 'text/html'
         writer = start_response("200 OK", headers.items())
-        if environ.get('REQUEST_METHOD') == 'HEAD':
-            # No content for a HEAD request
-            return []
         template = load_template(self.template_path)
         z = time.time()
         w = BufferingWriter(writer, 8192)
@@ -117,10 +112,6 @@
         if h is None:
             return None
         if len(self.args) > 0 and self.args != ['']:
-            try:
-                revid = h.fix_revid(self.args[0])
-            except bzrlib.errors.NoSuchRevision:
-                raise HTTPNotFound;
+            return h.fix_revid(self.args[0])
         else:
-            revid = h.last_revid
-        return revid
+            return h.last_revid

=== renamed file 'loggerhead/controllers/view_ui.py' => 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/view_ui.py	2010-12-01 08:30:02 +0000
+++ loggerhead/controllers/annotate_ui.py	2009-10-17 06:35:33 +0000
@@ -35,18 +35,20 @@
 from loggerhead import util
 
 
-class ViewUI(TemplatedBranchView):
-
-    template_path = 'loggerhead.templates.view'
-    
-    def tree_for(self, file_id, revid):
+class AnnotateUI(TemplatedBranchView):
+
+    template_path = 'loggerhead.templates.annotate'
+
+    def annotate_file(self, file_id, revid):
+        z = time.time()
+        lineno = 1
+        parity = 0
+
         file_revid = self._history.get_inventory(revid)[file_id].revision
-        return self._history._branch.repository.revision_tree(file_revid)
+        tree = self._history._branch.repository.revision_tree(file_revid)
 
-    def text_lines(self, file_id, revid):
         file_name = os.path.basename(self._history.get_path(revid, file_id))
-        
-        tree = self.tree_for(file_id, revid)
+
         file_text = tree.get_file_text(file_id)
         encoding = 'utf-8'
         try:
@@ -56,27 +58,44 @@
             file_text = file_text.decode(encoding)
 
         file_lines = bzrlib.osutils.split_lines(file_text)
-        # This can throw bzrlib.errors.BinaryFile (which our caller catches).
-        bzrlib.textfile.check_text_lines(file_lines)
-        
-        if highlight is not None:
-            hl_lines = highlight(file_name, file_text, encoding)
-            # highlight strips off extra newlines at the end of the file.
-            extra_lines = len(file_lines) - len(hl_lines)
-            hl_lines.extend([u''] * extra_lines)
-        else:
-            hl_lines = map(cgi.escape, file_lines)
-        
-        return hl_lines;
 
-    def file_contents(self, file_id, revid):
         try:
-            file_lines = self.text_lines(file_id, revid)
+            bzrlib.textfile.check_text_lines(file_lines)
         except bzrlib.errors.BinaryFile:
             # bail out; this isn't displayable text
-            return ['(This is a binary file.)']
-
-        return file_lines
+            yield util.Container(parity=0, lineno=1, status='same',
+                                 text='(This is a binary file.)',
+                                 change=util.Container())
+        else:
+            if highlight is not None:
+                hl_lines = highlight(file_name, file_text, encoding)
+                hl_lines.extend([u''] * (len(file_lines) - len(hl_lines)))
+            else:
+                hl_lines = map(cgi.escape, file_lines)
+
+            change_cache = {}
+
+            last_line_revid = None
+            for line_revid, text in tree.annotate_iter(file_id):
+                if line_revid == last_line_revid:
+                    # remember which lines have a new revno and which don't
+                    status = 'same'
+                else:
+                    status = 'changed'
+                    parity ^= 1
+                    last_line_revid = line_revid
+                    if line_revid in change_cache:
+                        change = change_cache[line_revid]
+                    else:
+                        change = self._history.get_changes([line_revid])[0]
+                        change_cache[line_revid] = change
+
+                yield util.Container(
+                    parity=parity, lineno=lineno, status=status,
+                    change=change, text=hl_lines[lineno - 1])
+                lineno += 1
+
+        self.log.debug('annotate: %r secs' % (time.time() - z,))
 
     def get_values(self, path, kwargs, headers):
         history = self._history
@@ -86,7 +105,7 @@
         file_id = kwargs.get('file_id', None)
         if (file_id is None) and (path is None):
             raise HTTPBadRequest('No file_id or filename '
-                                 'provided to view')
+                                 'provided to annotate')
 
         if file_id is None:
             file_id = history.get_file_id(revid, path)
@@ -121,17 +140,13 @@
         branch_breadcrumbs = util.branch_breadcrumbs(path, inv, 'files')
 
         return {
-            # In AnnotateUI, "annotated" is a generator giving revision
-            # numbers per lines, but the template checks if "annotated" is
-            # true or not before using it, so we have to define it here also.
-            'annotated': False,
             'revno_url': revno_url,
             'file_id': file_id,
-            'file_path': path,
+            'path': path,
             'filename': filename,
             'navigation': navigation,
             'change': change,
-            'contents':  self.file_contents(file_id, revid),
+            'contents': list(self.annotate_file(file_id, revid)),
             'fileview_active': True,
             'directory_breadcrumbs': directory_breadcrumbs,
             'branch_breadcrumbs': branch_breadcrumbs,

=== removed file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2010-12-01 08:30:02 +0000
+++ loggerhead/controllers/annotate_ui.py	1970-01-01 00:00:00 +0000
@@ -1,54 +0,0 @@
-#
-# Copyright (C) 2010 Canonical Ltd.
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-from loggerhead.controllers.view_ui import ViewUI
-from loggerhead import util
-
-class AnnotateUI(ViewUI):
-
-    def annotate_file(self, info):
-        file_id = info['file_id']
-        revid = info['change'].revid
-        
-        tree = self.tree_for(file_id, revid)
-        
-        change_cache = {}
-        last_line_revid = None
-        parity = 1
-        for line_revid, text in tree.annotate_iter(file_id):
-            if line_revid == last_line_revid:
-                # remember which lines have a new revno and which don't
-                new_rev = False
-            else:
-                new_rev = True
-                parity ^= 1
-                last_line_revid = line_revid
-                if line_revid in change_cache:
-                    change = change_cache[line_revid]
-                else:
-                    change = self._history.get_changes([line_revid])[0]
-                    change_cache[line_revid] = change
-
-            yield util.Container(
-                parity=parity, new_rev=new_rev, change=change)
-            
-    def get_values(self, path, kwargs, headers):
-        values = super(AnnotateUI, self).get_values(path, kwargs, headers)
-        values['annotated'] = self.annotate_file(values)
-        
-        return values

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2010-04-22 08:52:59 +0000
+++ loggerhead/controllers/changelog_ui.py	2009-06-25 03:35:43 +0000
@@ -106,7 +106,7 @@
             'navigation': navigation,
             'filter_file_id': filter_file_id,
             'start_revid': start_revid,
-            'viewing_from': (orig_start_revid is not None) and
+            'viewing_from': (orig_start_revid is not None) and 
                             (orig_start_revid != history.last_revid),
             'query': query,
             'search_failed': search_failed,

=== modified file 'loggerhead/controllers/diff_ui.py'
--- loggerhead/controllers/diff_ui.py	2010-04-08 01:08:33 +0000
+++ loggerhead/controllers/diff_ui.py	2009-10-17 08:59:33 +0000
@@ -72,7 +72,7 @@
         filename = '%s_%s.diff' % (revno1, revno2)
         headers = [
             ('Content-Type', 'application/octet-stream'),
-            ('Content-Length', str(len(content))),
+            ('Content-Length', len(content)),
             ('Content-Disposition', 'attachment; filename=%s' % (filename,)),
             ]
         start_response('200 OK', headers)

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2010-05-05 19:03:40 +0000
+++ loggerhead/controllers/download_ui.py	2009-10-17 09:21:55 +0000
@@ -44,8 +44,8 @@
             args.append(arg)
 
         if len(args) < 2:
-            raise httpexceptions.HTTPMovedPermanently(
-                self._branch.absolute_url('/changes'))
+            raise httpexceptions.HTTPMovedPermanently(self._branch.url(
+                      '../changes'))
 
         revid = h.fix_revid(args[0])
         file_id = args[1]
@@ -61,7 +61,7 @@
         encoded_filename = urllib.quote(filename.encode('utf-8'))
         headers = [
             ('Content-Type', mime_type),
-            ('Content-Length', str(len(content))),
+            ('Content-Length', len(content)),
             ('Content-Disposition',
              "attachment; filename*=utf-8''%s" % (encoded_filename,)),
             ]

=== modified file 'loggerhead/highlight.py'
--- loggerhead/highlight.py	2010-12-01 08:30:02 +0000
+++ loggerhead/highlight.py	2009-05-16 06:03:47 +0000
@@ -16,9 +16,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import bzrlib.osutils
-import cgi
-
 from pygments import highlight as _highlight_func
 from pygments.lexers import guess_lexer, guess_lexer_for_filename, TextLexer
 from pygments.formatters import HtmlFormatter
@@ -26,19 +23,12 @@
 
 DEFAULT_PYGMENT_STYLE = 'colorful'
 
-# Trying to highlight very large files using pygments was killing
-# loggerhead on launchpad.net, because pygments isn't very fast.
-# So we only highlight files if they're 512K or smaller.
-MAX_HIGHLIGHT_SIZE = 512000;
 
 def highlight(path, text, encoding, style=DEFAULT_PYGMENT_STYLE):
     """
     Returns a list of highlighted (i.e. HTML formatted) strings.
     """
 
-    if len(text) > MAX_HIGHLIGHT_SIZE:
-        return map(cgi.escape,  bzrlib.osutils.split_lines(text))
-
     formatter = HtmlFormatter(style=style, nowrap=True, classprefix='pyg-')
 
     try:
@@ -49,7 +39,6 @@
         except (ClassNotFound, ValueError):
             lexer = TextLexer(encoding=encoding)
 
-    hl_lines = _highlight_func(text, lexer, formatter)
-    hl_lines = bzrlib.osutils.split_lines(hl_lines)
+    hl_lines = _highlight_func(text, lexer, formatter).split('\n')
 
     return hl_lines

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2010-05-10 13:48:25 +0000
+++ loggerhead/history.py	2010-02-26 04:37:13 +0000
@@ -152,9 +152,6 @@
                 filename=rich_filename(paths[1], kind),
                 file_id=file_id))
 
-# The lru_cache is not thread-safe, so we need a lock around it for
-# all threads.
-rev_info_memory_cache_lock = threading.RLock()
 
 class RevInfoMemoryCache(object):
     """A store that validates values against the revids they were stored with.
@@ -178,11 +175,7 @@
         If a value was stored under `key`, with the same revid, return it.
         Otherwise return None.
         """
-        rev_info_memory_cache_lock.acquire()
-        try:
-            cached = self._cache.get(key)
-        finally:
-            rev_info_memory_cache_lock.release()
+        cached = self._cache.get(key)
         if cached is None:
             return None
         stored_revid, data = cached
@@ -194,11 +187,7 @@
     def set(self, key, revid, data):
         """Store `data` under `key`, to be checked against `revid` on get().
         """
-        rev_info_memory_cache_lock.acquire()
-        try:
-            self._cache[key] = (revid, data)
-        finally:
-            rev_info_memory_cache_lock.release()
+        self._cache[key] = (revid, data)
 
 # Used to store locks that prevent multiple threads from building a 
 # revision graph for the same branch at the same time, because that can
@@ -294,7 +283,6 @@
         else:
             self._file_change_cache = None
         self._branch = branch
-        self._branch_tags = None
         self._inventory_cache = {}
         self._branch_nick = self._branch.get_config().get_nickname()
         self.log = logging.getLogger('loggerhead.%s' % (self._branch_nick,))
@@ -665,12 +653,11 @@
         """
         message, short_message = clean_message(revision.message)
 
-        if self._branch_tags is None:
-            self._branch_tags = self._branch.tags.get_reverse_tag_dict()
+        tags = self._branch.tags.get_reverse_tag_dict()
 
         revtags = None
-        if revision.revision_id in self._branch_tags:
-          revtags = ', '.join(self._branch_tags[revision.revision_id])
+        if tags.has_key(revision.revision_id):
+          revtags = ', '.join(tags[revision.revision_id])
 
         entry = {
             'revid': revision.revision_id,

=== removed file 'loggerhead/load_test.py'
--- loggerhead/load_test.py	2011-02-10 01:00:32 +0000
+++ loggerhead/load_test.py	1970-01-01 00:00:00 +0000
@@ -1,233 +0,0 @@
-# Copyright 2011 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Code to do some load testing against a loggerhead instance.
-
-This is basically meant to take a list of actions to take, and run it against a
-real host, and see how the results respond.::
-
-    {"parameters": {
-         "base_url": "http://localhost:8080",
-     },
-     "requests": [
-        {"thread": "1", "relpath": "/changes"},
-        {"thread": "1", "relpath": "/changes"},
-        {"thread": "1", "relpath": "/changes"},
-        {"thread": "1", "relpath": "/changes"}
-     ],
-    }
-
-All threads have a Queue length of 1. When a third request for a given thread
-is seen, no more requests are queued until that thread finishes its current
-job. So this results in all requests being issued sequentially::
-
-        {"thread": "1", "relpath": "/changes"},
-        {"thread": "1", "relpath": "/changes"},
-        {"thread": "1", "relpath": "/changes"},
-        {"thread": "1", "relpath": "/changes"}
-
-While this would cause all requests to be sent in parallel:
-
-        {"thread": "1", "relpath": "/changes"},
-        {"thread": "2", "relpath": "/changes"},
-        {"thread": "3", "relpath": "/changes"},
-        {"thread": "4", "relpath": "/changes"}
-
-This should keep 2 threads pipelined with activity, as long as they finish in
-approximately the same speed. We'll start the first thread running, and the
-second thread, and queue up both with a second request once the first finishes.
-When we get to the third request for thread "1", we block on queuing up more
-work until the first thread 1 request has finished.
-        {"thread": "1", "relpath": "/changes"},
-        {"thread": "2", "relpath": "/changes"},
-        {"thread": "1", "relpath": "/changes"},
-        {"thread": "2", "relpath": "/changes"},
-        {"thread": "1", "relpath": "/changes"},
-        {"thread": "2", "relpath": "/changes"}
-
-There is not currently a way to say "run all these requests keeping exactly 2
-threads active". Though if you know the load pattern, you could approximate
-this.
-"""
-
-import threading
-import time
-import Queue
-
-try:
-    import simplejson
-except ImportError:
-    import json as simplejson
-
-from bzrlib import (
-    errors,
-    transport,
-    urlutils,
-    )
-
-# This code will be doing multi-threaded requests against bzrlib.transport
-# code. We want to make sure to load everything ahead of time, so we don't get
-# lazy-import failures
-_ = transport.get_transport('http://example.com')
-
-
-class RequestDescription(object):
-    """Describes info about a request."""
-
-    def __init__(self, descrip_dict):
-        self.thread = descrip_dict.get('thread', '1')
-        self.relpath = descrip_dict['relpath']
-
-
-class RequestWorker(object):
-    """Process requests in a worker thread."""
-
-    _timer = time.time
-
-    def __init__(self, identifier, blocking_time=1.0, _queue_size=1):
-        self.identifier = identifier
-        self.queue = Queue.Queue(_queue_size)
-        self.start_time = self.end_time = None
-        self.stats = []
-        self.blocking_time = blocking_time
-
-    def step_next(self):
-        url = self.queue.get(True, self.blocking_time)
-        if url == '<noop>':
-            # This is usually an indicator that we want to stop, so just skip
-            # this one.
-            self.queue.task_done()
-            return
-        self.start_time = self._timer()
-        success = self.process(url)
-        self.end_time = self._timer()
-        self.update_stats(url, success)
-        self.queue.task_done()
-
-    def run(self, stop_event):
-        while not stop_event.isSet():
-            try:
-                self.step_next()
-            except Queue.Empty:
-                pass
-
-    def process(self, url):
-        base, path = urlutils.split(url)
-        t = transport.get_transport(base)
-        try:
-            # TODO: We should probably look into using some part of
-            #       blocking_timeout to decide when to stop trying to read
-            #       content
-            content = t.get_bytes(path)
-        except (errors.TransportError, errors.NoSuchFile):
-            return False
-        return True
-
-    def update_stats(self, url, success):
-        self.stats.append((url, success, self.end_time - self.start_time))
-
-
-class ActionScript(object):
-    """This tracks the actions that we want to perform."""
-
-    _worker_class = RequestWorker
-    _default_base_url = 'http://localhost:8080'
-    _default_blocking_timeout = 60.0
-
-    def __init__(self):
-        self.base_url = self._default_base_url
-        self.blocking_timeout = self._default_blocking_timeout
-        self._requests = []
-        self._threads = {}
-        self.stop_event = threading.Event()
-
-    @classmethod
-    def parse(cls, content):
-        script = cls()
-        json_dict = simplejson.loads(content)
-        if 'parameters' not in json_dict:
-            raise ValueError('Missing "parameters" section')
-        if 'requests' not in json_dict:
-            raise ValueError('Missing "requests" section')
-        param_dict = json_dict['parameters']
-        request_list = json_dict['requests']
-        base_url = param_dict.get('base_url', None)
-        if base_url is not None:
-            script.base_url = base_url
-        blocking_timeout = param_dict.get('blocking_timeout', None)
-        if blocking_timeout is not None:
-            script.blocking_timeout = blocking_timeout
-        for request_dict in request_list:
-            script.add_request(request_dict)
-        return script
-
-    def add_request(self, request_dict):
-        request = RequestDescription(request_dict)
-        self._requests.append(request)
-
-    def _get_worker(self, thread_id):
-        if thread_id in self._threads:
-            return self._threads[thread_id][0]
-        handler = self._worker_class(thread_id,
-                                     blocking_time=self.blocking_timeout/10.0)
-
-        t = threading.Thread(target=handler.run, args=(self.stop_event,),
-                             name='Thread-%s' % (thread_id,))
-        self._threads[thread_id] = (handler, t)
-        t.start()
-        return handler
-
-    def finish_queues(self):
-        """Wait for all queues of all children to finish."""
-        for h, t in self._threads.itervalues():
-            h.queue.join()
-
-    def stop_and_join(self):
-        """Stop all running workers, and return.
-
-        This will stop even if workers still have work items.
-        """
-        self.stop_event.set()
-        for h, t in self._threads.itervalues():
-            # Signal the queue that it should stop blocking, we don't have to
-            # wait for the queue to empty, because we may see stop_event before
-            # we see the <noop>
-            h.queue.put('<noop>')
-            # And join the controlling thread
-            for i in range(10):
-                t.join(self.blocking_timeout / 10.0)
-                if not t.isAlive():
-                    break
-
-    def _full_url(self, relpath):
-        return self.base_url + relpath
-
-    def run(self):
-        self.stop_event.clear()
-        for request in self._requests:
-            full_url = self._full_url(request.relpath)
-            worker = self._get_worker(request.thread)
-            worker.queue.put(full_url, True, self.blocking_timeout)
-        self.finish_queues()
-        self.stop_and_join()
-
-
-def run_script(filename):
-    with open(filename, 'rb') as f:
-        content = f.read()
-    script = ActionScript.parse(content)
-    script.run()
-    return script

=== renamed file 'loggerhead/static/css/view.css' => 'loggerhead/static/css/annotate.css'
--- loggerhead/static/css/view.css	2010-12-01 08:30:02 +0000
+++ loggerhead/static/css/annotate.css	2009-03-01 20:57:52 +0000
@@ -1,31 +1,29 @@
 /*table*/
-.viewLineTit, .viewLine, .viewRevTit, .viewRev,
-.viewContTit, .viewCont
-{
+.annoLineTit, .annoLine, .annoRevTit, .annoRev, .annoComm, .annoCommTit, .annoContTit, .annoCont {
+	width:45px;
 	border:1px solid #d2d2d2;
 }
-.viewLine, .viewRev, .viewComm, .viewCont {
-	border:none;
-}
-.viewLine, .viewLineTit {
-	padding-right: .2em;
-}
-.viewLine {
+.annoLine, .annoRev, .annoComm, .annoCont {
+	border:none;	
+}
+.annoLine {
 	width:37px;
 }
-.viewContTit, .viewCont {
+.annoContTit, .annoCont {
 	width:auto;
-	padding-left: .3em;
 }
-.viewRevTit, .viewRev {
+.annoRevTit, .annoRev {
 	width:70px;
 	text-align:center;
 }
-.viewLine, .viewCont {
+.annoComm, .annoCommTit {
+	width:200px;
+}
+.annoLine, .annoCont {
 	font:normal 12px/normal monospace;
         whitespace: pre;
 }
-.viewCont pre { margin: 0; }
-.viewLine {
+.annoCont pre { margin: 0; }
+.annoLine {
 	text-align:right;
 }

=== modified file 'loggerhead/static/css/global.css'
--- loggerhead/static/css/global.css	2010-04-23 01:30:29 +0000
+++ loggerhead/static/css/global.css	2009-06-11 21:16:27 +0000
@@ -96,27 +96,27 @@
 	text-align:center;
 	color:#fff;
 	text-decoration:none;
-	background:#d18b39;
+	background:#2f40a5;
 }
 ul#submenuTabs li {
 	float:left;
 	display:inline;
 	margin-left:1px;
 	color:#fff;
-	background:#d18b39;
+	background:#2f40a5;
 }
 ul#submenuTabs li a:hover {
 	float:left;
 	display:inline;
 	color:#fff;
-	background:#d18b39;
+	background:#2f40a5;
 	text-decoration:underline;
 }
 ul#submenuTabs li#first a, ul#submenuTabs li#first a:link, ul#submenuTabs li#first a:visited, ul#submenuTabs li#first a:hover {
-	background:#d18b39 url(../images/bg_submenuTabs.gif) top left no-repeat;
+	background:#2f40a5 url(../images/bg_submenuTabs.gif) top left no-repeat;
 }
 ul#submenuTabs li#last a, ul#submenuTabs li#last a:link, ul#submenuTabs li#last a:visited, ul#submenuTabs li#last a:hover {
-	background:#d18b39 url(../images/bg_submenuTabs.gif) bottom right no-repeat;
+	background:#2f40a5 url(../images/bg_submenuTabs.gif) bottom right no-repeat;
 }
 
 /* Search & RSS */
@@ -180,7 +180,7 @@
 }
 #loggerheadCont p.expand, #loggerheadCont p.expand a, #loggerheadCont p.expand a:link, #loggerheadCont p.expand a:visited, #loggerheadCont p.expand a:hover {
 	color:#000;
-	text-decoration:none;
+	text-decoration:none;	
 }
 #loggerheadCont p img {
 	vertical-align:middle;
@@ -192,7 +192,7 @@
 }
 .revnolink a, .revnolink a:visited, .revnolink a:link, .revnolink a:hover {
 	color:#CC6600;
-	text-decoration:none;
+	text-decoration:none;		
 }
 
 /*Log Table*/
@@ -214,7 +214,7 @@
 }
 .blueRow0, .blueRow1 {
 	background:#eef6fa;
-	font:normal 14px/normal sans-serif;
+	font:normal 14px/normal sans-serif;	
 	padding:0px;
 	margin:0px;
 }
@@ -228,7 +228,7 @@
 	border:1px solid #d2d2d2;
 }
 .expandcell, .expcell {
-	width:28px;
+	width:28px;	
 }
 .summarycell, .authorcell, .tagscell, .datecell, .timedate{
   padding: 4px 8px;

=== modified file 'loggerhead/static/images/bg_Tabs.gif'
Binary files loggerhead/static/images/bg_Tabs.gif and loggerhead/static/images/bg_Tabs.gif differ
=== modified file 'loggerhead/static/images/bg_menuTabs.gif'
Binary files loggerhead/static/images/bg_menuTabs.gif and loggerhead/static/images/bg_menuTabs.gif differ
=== modified file 'loggerhead/static/images/bg_submenuTabs.gif'
Binary files loggerhead/static/images/bg_submenuTabs.gif and loggerhead/static/images/bg_submenuTabs.gif differ
=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2010-12-01 08:30:02 +0000
+++ loggerhead/templatefunctions.py	2009-10-17 08:47:38 +0000
@@ -121,9 +121,9 @@
 
 
 @templatefunc
-def view_link(url, revno, path):
+def annotate_link(url, revno, path):
     return '<a href="%s" title="Annotate %s">%s</a>' % (
-        url(['/view', revno, path]), cgi.escape(path), cgi.escape(path))
+        url(['/annotate', revno, path]), cgi.escape(path), cgi.escape(path))
 
 @templatefunc
 def revision_link(url, revno, path, frag=''):

=== renamed file 'loggerhead/templates/view.pt' => 'loggerhead/templates/annotate.pt'
--- loggerhead/templates/view.pt	2010-12-01 08:30:02 +0000
+++ loggerhead/templates/annotate.pt	2009-03-06 09:57:54 +0000
@@ -3,12 +3,12 @@
 <html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros/main">
   <head>
     <title metal:fill-slot="title"
-           tal:content="string:${branch/friendly_name} : contents of ${file_path}
+           tal:content="string:${branch/friendly_name} : contents of ${path}
                         at revision ${change/revno}">
     </title>
     <metal:block fill-slot="header_extras">
         <link rel="stylesheet" type="text/css" media="all"
-              tal:attributes="href python:branch.static_url('/static/css/view.css')"/>
+              tal:attributes="href python:branch.static_url('/static/css/annotate.css')"/>
         <link rel="stylesheet" type="text/css" media="all"
               tal:attributes="href python:branch.static_url('/static/css/highlight.css')"/>
     </metal:block>
@@ -36,14 +36,6 @@
             <li id="first">
                 <a tal:attributes="href python:url(['/files', change.revno], clear=1)">browse files</a>
             </li>
-            <li tal:condition="not:annotated">
-              <a tal:attributes="href python:url(['/annotate', revno_url, file_path], clear=1)"
-              >view revision numbers per line</a>
-            </li>
-            <li tal:condition="annotated">
-              <a tal:attributes="href python:url(['/view', revno_url, file_path], clear=1)"
-              >view without revision numbers</a>
-            </li>
             <li>
                 <a tal:attributes="href python:url(['/revision', change.revno], clear=1)">view revision</a>
             </li>
@@ -58,30 +50,25 @@
             </li>
         </ul>
 
-      <div class="view">
+      <div class="annotate">
         <table id="logentries">
           <tr class="logheader">
-            <td class="viewLineTit">Line</td>
-            <td class="viewRevTit" tal:condition="annotated">Revision</td>
-            <td class="viewContTit">Contents</td>
+            <td class="annoLineTit">Line</td>
+            <td class="annoRevTit">Revision</td>
+            <td class="annoContTit">Contents</td>
           </tr>
 
-          <tal:rep tal:repeat="line contents">
-            <tr tal:define="anno python:annotated and annotated.next()"
-                tal:attributes="class python:anno and 'blueRow' + str(anno.parity) or None">
-              <td class="viewLine">
-                <a tal:attributes="id string:L${repeat/line/number}; href string:#L${repeat/line/number}"
-                   tal:content="repeat/line/number">1</a>
-              </td>
-              <td class="viewRev" tal:condition="annotated">
-                <a tal:condition="python:anno.new_rev"
-                   tal:content="python:util.trunc(anno.change.revno)"
-                   tal:attributes="href python:url(['/revision', anno.change.revno], clear=1);
-                                   title python:'%s by %s, on %s (%s)' % (anno.change.revno, ', '.join(util.hide_emails(anno.change.authors)), anno.change.date.strftime('%d %b %Y %H:%M'), util.date_time(anno.change.date))"></a>
-              </td>
-              <td class="viewCont"><pre tal:content="structure line"></pre></td>
-            </tr>
-          </tal:rep>
+          <tr tal:repeat="line contents" 
+              tal:attributes="class string:blueRow${line/parity}">
+            <td class="annoLine"><a tal:attributes="id string:L${line/lineno}; href string:#L${line/lineno}" tal:content="line/lineno">1</a></td>
+            <td class="annoRev">
+              <a tal:condition="python:line.status=='changed'"
+                 tal:content="python:util.trunc(line.change.revno)"
+                 tal:attributes="href python:url(['/revision', line.change.revno], clear=1);
+                                 title python:'%s by %s, on %s (%s)'%(line.change.revno, ', '.join(util.hide_emails(line.change.authors)), line.change.date.strftime('%d %b %Y %H:%M'), util.date_time(line.change.date))"></a>
+            </td>
+            <td class="annoCont"><pre tal:content="structure line/text"></pre></td>
+          </tr>
         </table>
       </div>
 

=== modified file 'loggerhead/templates/atom.pt'
--- loggerhead/templates/atom.pt	2010-05-05 18:42:58 +0000
+++ loggerhead/templates/atom.pt	2009-06-06 12:23:11 +0000
@@ -4,8 +4,8 @@
     bazaar changes for <tal:branch-name content="branch/friendly_name">branch name</tal:branch-name>
   </title>
   <updated tal:content="string:${updated}Z">${updated}</updated>
-  <id tal:content="python:branch.absolute_url(['/atom'])">url</id>
-  <link rel="self" type="application/atom+xml" tal:attributes="href python:branch.absolute_url(['/atom'])" />
+  <id tal:content="python:branch.url(['/atom'])">url</id>
+  <link rel="self" type="application/atom+xml" tal:attributes="href python:branch.url(['/atom'])" />
   <link rel="alternate" type="text/html" tal:attributes="href python:branch.url(['/changes'])" />
 
   <entry tal:repeat="entry changes">
@@ -16,7 +16,7 @@
       updated
     </updated>
     <!-- TODO: The feed validator will generate warnings because this is URL-encoded -->
-    <id tal:content="python:branch.absolute_url(['/revision', entry.revno])">
+    <id tal:content="python:branch.url(['/revision', entry.revno])">
       ID
     </id>
     <author tal:repeat="author entry/authors">

=== modified file 'loggerhead/templates/browse.pt'
--- loggerhead/templates/browse.pt	2009-10-17 06:55:25 +0000
+++ loggerhead/templates/browse.pt	2009-05-13 13:14:04 +0000
@@ -28,7 +28,7 @@
                   <img tal:attributes="src python:branch.static_url('/static/images/ico_branch.gif')" alt="Branch" />
                 </td>
                 <td class="autcell">
-                    <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name)"
+                    <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name)" 
                        tal:content="view/friendly_name" />
                 </td>
                 <td class="autcell"

=== modified file 'loggerhead/templates/directory.pt'
--- loggerhead/templates/directory.pt	2010-04-13 23:35:01 +0000
+++ loggerhead/templates/directory.pt	2009-11-27 00:14:35 +0000
@@ -19,7 +19,7 @@
             <th class="datecell">Latest Rev</th>
             <th class="datecell">Last Changed</th>
           </tr>
-
+          
           <tr class="blueRow0" tal:condition="python:name != '/'">
             <td class="icocell">
                 <a href="../"><img tal:attributes="src python:static_url('/static/images/ico_folder_up.gif')" /></a>

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2010-12-01 08:30:02 +0000
+++ loggerhead/templates/inventory.pt	2009-07-15 22:02:09 +0000
@@ -70,7 +70,7 @@
                                              title string:Go to ${file/filename}" />
                     </a>
 
-                 <a tal:attributes="href python:url(['/files', revno_url, file.absolutepath])"
+                 <a tal:attributes="href python:url(['/files', revno_url, file.absolutepath])" 
                                         tal:content="file/filename" class="link"></a>
                  </td>
                  <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
@@ -89,11 +89,11 @@
 
             <!-- Show this if it's a symlink -->
             <tr tal:attributes="class string:blueRow${repeat/file/even}" tal:condition="python:file.kind=='symlink'">
-                <td class="autcell"><a tal:attributes="href python:url(['/view', change.revno, file.absolutepath])">
+                <td class="autcell"><a tal:attributes="href python:url(['/annotate', change.revno, file.absolutepath])">
                         <img tal:attributes="src python:branch.static_url('/static/images/ico_file_flecha.gif')" alt="Symlink" />
                     </a>
 
-                 <a tal:attributes="href python:url(['/view', revno_url, file.absolutepath])"
+                 <a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])" 
                                         tal:content="file/filename" class="link"></a>
                  </td>
                  <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
@@ -113,17 +113,17 @@
 
             <!-- Show this if it's a regular file -->
             <tr tal:attributes="class string:blueRow${repeat/file/even}" tal:condition="python:file.kind=='file'">
-                <td class="autcell"><a tal:attributes="href python:url(['/view', revno_url, file.absolutepath])">
+                <td class="autcell"><a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])">
                         <img tal:attributes="src python:branch.static_url('/static/images/ico_file.gif');
-                                             title string:View ${file/filename}"
+                                             title string:Annotate ${file/filename}"
                              tal:condition="python:file.executable is False" />
                         <!-- Show a different icon id the file executable -->
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_file_modify.gif');
-                                             title string:View ${file/filename}"
+                        <img tal:attributes="src python:branch.static_url('/static/images/ico_file_modify.gif'); 
+                                             title string:Annotate ${file/filename}"
                              tal:condition="python:file.executable is True" alt="File" />
                     </a>
 
-              <a tal:attributes="href python:url(['/view', revno_url, file.absolutepath])"
+              <a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])"
                                      tal:content="file/filename" class="link"></a></td>
               <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
                                                   title string:Show revision ${file/change/revno}"
@@ -131,8 +131,8 @@
               </td>
               <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
               <td class="timedate2" tal:content="python:util.human_size(file.size)"></td>
-              <td class="expcell"><a tal:attributes="href python:url(['/view', revno_url, file.absolutepath]);
-                                                     title string:View ${file/filename}">
+              <td class="expcell"><a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath]);
+                                                     title string:Annotate ${file/filename}">
                                       <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif')" alt="Diff" />
                                      </a>
               </td>

=== modified file 'loggerhead/templates/macros.pt'
--- loggerhead/templates/macros.pt	2009-07-21 04:39:33 +0000
+++ loggerhead/templates/macros.pt	2009-06-24 02:35:46 +0000
@@ -43,6 +43,14 @@
 
 <body>
     <!-- Loggerhead Content Area -->
+      <div id="finderBox">
+         <tal:search-box define="navigation navigation"
+                        replace="structure python:search_box(branch,
+                                 navigation)" />
+        <div>
+          <tal:feed-link replace="structure python:feed_link(branch, url)" />
+        </div>
+      </div>
 
       <tal:menu define="fileview_active fileview_active"
                 replace="structure python:menu(branch, url, fileview_active)" />

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2010-12-01 08:30:02 +0000
+++ loggerhead/templates/revision.pt	2009-04-28 03:01:54 +0000
@@ -20,6 +20,7 @@
     </head>
 
     <body>
+
       <tal:block metal:fill-slot="heading">
         <h1>
           <tal:has-link condition="branch/branch_link">
@@ -41,7 +42,7 @@
             </tal:compare-to>
           </span>
           <span class="breadcrumb" tal:condition="specific_path">
-            : <tal:annotate content="structure python:view_link(url, change.revno, specific_path)" />
+            : <tal:annotate content="structure python:annotate_link(url, change.revno, specific_path)" />
           </span>
         </h1>
         <tal:branch-info replace="structure python:branchinfo(branch)" />
@@ -54,7 +55,7 @@
           </a>
         </p>
         <p tal:condition="specific_path">
-          Viewing changes to <tal:annotate content="structure python:view_link(url, change.revno, specific_path)" />
+          Viewing changes to <tal:annotate content="structure python:annotate_link(url, change.revno, specific_path)" />
         </p>
         <ul id="submenuTabs">
           <li id="first"><a tal:attributes="href python:url(['/files', change.revno]);

=== modified file 'loggerhead/tests/__init__.py'
--- loggerhead/tests/__init__.py	2011-02-09 21:17:32 +0000
+++ loggerhead/tests/__init__.py	2006-12-11 06:44:19 +0000
@@ -1,27 +0,0 @@
-# Copyright 2006, 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-def load_tests(standard_tests, module, loader):
-    standard_tests.addTests(loader.loadTestsFromModuleNames([
-        (__name__ + '.' + x) for x in [
-            'test_controllers',
-            'test_corners',
-            'test_load_test',
-            'test_simple',
-            'test_templating',
-        ]]))
-    return standard_tests

=== modified file 'loggerhead/tests/test_controllers.py'
--- loggerhead/tests/test_controllers.py	2011-02-10 17:01:10 +0000
+++ loggerhead/tests/test_controllers.py	2009-03-19 18:48:15 +0000
@@ -1,10 +1,3 @@
-from cStringIO import StringIO
-import logging
-
-from paste.httpexceptions import HTTPServerError
-
-from bzrlib import errors
-
 from loggerhead.apps.branch import BranchWSGIApp
 from loggerhead.controllers.annotate_ui import AnnotateUI
 from loggerhead.controllers.inventory_ui import InventoryUI
@@ -22,50 +15,15 @@
         tree.commit('')
         tree.branch.lock_read()
         self.addCleanup(tree.branch.unlock)
-        branch_app = BranchWSGIApp(tree.branch, '')
-        branch_app.log.setLevel(logging.CRITICAL)
-        # These are usually set in BranchWSGIApp.app(), which is set from env
-        # settings set by BranchesFromTransportRoot, so we fake it.
-        branch_app._static_url_base = '/'
-        branch_app._url_base = '/'
+        branch_app = BranchWSGIApp(tree.branch)
         return tree.branch, InventoryUI(branch_app, branch_app.get_history)
 
-    def consume_app(self, app, extra_environ=None):
-        env = {'SCRIPT_NAME': '/files', 'PATH_INFO': ''}
-        if extra_environ is not None:
-            env.update(extra_environ)
-        body = StringIO()
-        start = []
-        def start_response(status, headers, exc_info=None):
-            start.append((status, headers, exc_info))
-            return body.write
-        extra_content = list(app(env, start_response))
-        body.writelines(extra_content)
-        return start[0], body.getvalue()
-
     def test_get_filelist(self):
         bzrbranch, inv_ui = self.make_bzrbranch_and_inventory_ui_for_tree_shape(
             ['filename'])
         inv = bzrbranch.repository.get_inventory(bzrbranch.last_revision())
         self.assertEqual(1, len(inv_ui.get_filelist(inv, '', 'filename')))
 
-    def test_smoke(self):
-        bzrbranch, inv_ui = self.make_bzrbranch_and_inventory_ui_for_tree_shape(
-            ['filename'])
-        start, content = self.consume_app(inv_ui)
-        self.assertEqual(('200 OK', [('Content-Type', 'text/html')], None),
-                         start)
-        self.assertContainsRe(content, 'filename')
-
-    def test_no_content_for_HEAD(self):
-        bzrbranch, inv_ui = self.make_bzrbranch_and_inventory_ui_for_tree_shape(
-            ['filename'])
-        start, content = self.consume_app(inv_ui,
-                            extra_environ={'REQUEST_METHOD': 'HEAD'})
-        self.assertEqual(('200 OK', [('Content-Type', 'text/html')], None),
-                         start)
-        self.assertEqual('', content)
-
 
 class TestRevisionUI(BasicTests):
 
@@ -103,25 +61,20 @@
 
     def make_annotate_ui_for_file_history(self, file_id, rev_ids_texts):
         tree = self.make_branch_and_tree('.')
-        self.build_tree_contents([('filename', '')])
+        open('filename', 'w').write('')
         tree.add(['filename'], [file_id])
         for rev_id, text in rev_ids_texts:
-            self.build_tree_contents([('filename', text)])
+            open('filename', 'w').write(text)
             tree.commit(rev_id=rev_id, message='.')
         tree.branch.lock_read()
         self.addCleanup(tree.branch.unlock)
-        branch_app = BranchWSGIApp(tree.branch, friendly_name='test_name')
+        branch_app = BranchWSGIApp(tree.branch)
         return AnnotateUI(branch_app, branch_app.get_history)
 
     def test_annotate_file(self):
         history = [('rev1', 'old\nold\n'), ('rev2', 'new\nold\n')]
         ann_ui = self.make_annotate_ui_for_file_history('file_id', history)
-        # A lot of this state is set up by __call__, but we'll do it directly
-        # here.
-        ann_ui.args = ['rev2']
-        annotate_info = ann_ui.get_values('filename',
-            kwargs={'file_id': 'file_id'}, headers={})
-        annotated = list(annotate_info['annotated'])
+        annotated = list(ann_ui.annotate_file('file_id', 'rev2'))
         self.assertEqual(2, len(annotated))
         self.assertEqual('2', annotated[0].change.revno)
         self.assertEqual('1', annotated[1].change.revno)

=== removed file 'loggerhead/tests/test_load_test.py'
--- loggerhead/tests/test_load_test.py	2011-02-10 00:49:06 +0000
+++ loggerhead/tests/test_load_test.py	1970-01-01 00:00:00 +0000
@@ -1,337 +0,0 @@
-# Copyright 2011 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#
-
-"""Tests for the load testing code."""
-
-import socket
-import time
-import threading
-import Queue
-
-from bzrlib import tests
-from bzrlib.tests import http_server
-
-from bzrlib.plugins.loggerhead.loggerhead import load_test
-
-
-empty_script = """{
-    "parameters": {},
-    "requests": []
-}"""
-
-class TestRequestDescription(tests.TestCase):
-
-    def test_init_from_dict(self):
-        rd = load_test.RequestDescription({'thread': '10', 'relpath': '/foo'})
-        self.assertEqual('10', rd.thread)
-        self.assertEqual('/foo', rd.relpath)
-
-    def test_default_thread_is_1(self):
-        rd = load_test.RequestDescription({'relpath': '/bar'})
-        self.assertEqual('1', rd.thread)
-        self.assertEqual('/bar', rd.relpath)
-
-
-_cur_time = time.time()
-def one_sec_timer():
-    """Every time this timer is called, it increments by 1 second."""
-    global _cur_time
-    _cur_time += 1.0
-    return _cur_time
-
-
-class NoopRequestWorker(load_test.RequestWorker):
-
-    # Every call to _timer will increment by one
-    _timer = staticmethod(one_sec_timer)
-
-    # Ensure that process never does anything
-    def process(self, url):
-        return True
-
-
-class TestRequestWorkerInfrastructure(tests.TestCase):
-    """Tests various infrastructure bits, without doing actual requests."""
-
-    def test_step_next_tracks_time(self):
-        rt = NoopRequestWorker('id')
-        rt.queue.put('item')
-        rt.step_next()
-        self.assertTrue(rt.queue.empty())
-        self.assertEqual([('item', True, 1.0)], rt.stats)
-
-    def test_step_multiple_items(self):
-        rt = NoopRequestWorker('id')
-        rt.queue.put('item')
-        rt.step_next()
-        rt.queue.put('next-item')
-        rt.step_next()
-        self.assertTrue(rt.queue.empty())
-        self.assertEqual([('item', True, 1.0), ('next-item', True, 1.0)],
-                         rt.stats)
-
-    def test_step_next_does_nothing_for_noop(self):
-        rt = NoopRequestWorker('id')
-        rt.queue.put('item')
-        rt.step_next()
-        rt.queue.put('<noop>')
-        rt.step_next()
-        self.assertEqual([('item', True, 1.0)], rt.stats)
-
-    def test_step_next_will_timeout(self):
-        # We don't want step_next to block forever
-        rt = NoopRequestWorker('id', blocking_time=0.001)
-        self.assertRaises(Queue.Empty, rt.step_next)
-
-    def test_run_stops_for_stop_event(self):
-        rt = NoopRequestWorker('id', blocking_time=0.001, _queue_size=2)
-        rt.queue.put('item1')
-        rt.queue.put('item2')
-        event = threading.Event()
-        t = threading.Thread(target=rt.run, args=(event,))
-        t.start()
-        # Wait for the queue to be processed
-        rt.queue.join()
-        # Now we can queue up another one, and wait for it
-        rt.queue.put('item3')
-        rt.queue.join()
-        # Now set the stopping event
-        event.set()
-        # Add another item to the queue, which might get processed, but the
-        # next item won't
-        rt.queue.put('item4')
-        rt.queue.put('item5')
-        t.join()
-        self.assertEqual([('item1', True, 1.0), ('item2', True, 1.0),
-                          ('item3', True, 1.0)],
-                         rt.stats[:3])
-        # The last event might be item4 or might be item3, the important thing
-        # is that even though there are still queued events, we won't
-        # process anything past the first
-        self.assertNotEqual('item5', rt.stats[-1][0])
-
-
-class TestRequestWorker(tests.TestCaseWithTransport):
-
-    def setUp(self):
-        super(TestRequestWorker, self).setUp()
-        self.transport_readonly_server = http_server.HttpServer
-
-    def test_request_items(self):
-        rt = load_test.RequestWorker('id', blocking_time=0.01, _queue_size=2)
-        self.build_tree(['file1', 'file2'])
-        readonly_url1 = self.get_readonly_url('file1')
-        self.assertStartsWith(readonly_url1, 'http://')
-        readonly_url2 = self.get_readonly_url('file2')
-        rt.queue.put(readonly_url1)
-        rt.queue.put(readonly_url2)
-        rt.step_next()
-        rt.step_next()
-        self.assertEqual(readonly_url1, rt.stats[0][0])
-        self.assertEqual(readonly_url2, rt.stats[1][0])
-
-    def test_request_nonexistant_items(self):
-        rt = load_test.RequestWorker('id', blocking_time=0.01, _queue_size=2)
-        readonly_url1 = self.get_readonly_url('no-file1')
-        rt.queue.put(readonly_url1)
-        rt.step_next()
-        self.assertEqual(readonly_url1, rt.stats[0][0])
-        self.assertEqual(False, rt.stats[0][1])
-
-    def test_no_server(self):
-        s = socket.socket()
-        # Bind to a port, but don't listen on it
-        s.bind(('localhost', 0))
-        url = 'http://%s:%s/path' % s.getsockname()
-        rt = load_test.RequestWorker('id', blocking_time=0.01, _queue_size=2)
-        rt.queue.put(url)
-        rt.step_next()
-        self.assertEqual((url, False), rt.stats[0][:2])
-
-
-class NoActionScript(load_test.ActionScript):
-
-    _thread_class = NoopRequestWorker
-    _default_blocking_timeout = 0.01
-
-
-class TestActionScriptInfrastructure(tests.TestCase):
-
-    def test_parse_requires_parameters_and_requests(self):
-        self.assertRaises(ValueError,
-            load_test.ActionScript.parse, '')
-        self.assertRaises(ValueError,
-            load_test.ActionScript.parse, '{}')
-        self.assertRaises(ValueError,
-            load_test.ActionScript.parse, '{"parameters": {}}')
-        self.assertRaises(ValueError,
-            load_test.ActionScript.parse, '{"requests": []}')
-        load_test.ActionScript.parse(
-            '{"parameters": {}, "requests": [], "comment": "section"}')
-        script = load_test.ActionScript.parse(
-            empty_script)
-        self.assertIsNot(None, script)
-
-    def test_parse_default_base_url(self):
-        script = load_test.ActionScript.parse(empty_script)
-        self.assertEqual('http://localhost:8080', script.base_url)
-
-    def test_parse_find_base_url(self):
-        script = load_test.ActionScript.parse(
-            '{"parameters": {"base_url": "http://example.com"},'
-            ' "requests": []}')
-        self.assertEqual('http://example.com', script.base_url)
-
-    def test_parse_default_blocking_timeout(self):
-        script = load_test.ActionScript.parse(empty_script)
-        self.assertEqual(60.0, script.blocking_timeout)
-
-    def test_parse_find_blocking_timeout(self):
-        script = load_test.ActionScript.parse(
-            '{"parameters": {"blocking_timeout": 10.0},'
-            ' "requests": []}'
-        )
-        self.assertEqual(10.0, script.blocking_timeout)
-
-    def test_parse_finds_requests(self):
-        script = load_test.ActionScript.parse(
-            '{"parameters": {}, "requests": ['
-            ' {"relpath": "/foo"},'
-            ' {"relpath": "/bar"}'
-            ' ]}')
-        self.assertEqual(2, len(script._requests))
-        self.assertEqual("/foo", script._requests[0].relpath)
-        self.assertEqual("/bar", script._requests[1].relpath)
-
-    def test__get_worker(self):
-        script = NoActionScript()
-        # If an id is found, then we should create it
-        self.assertEqual({}, script._threads)
-        worker = script._get_worker('id')
-        self.assertTrue('id' in script._threads)
-        # We should have set the blocking timeout
-        self.assertEqual(script.blocking_timeout / 10.0,
-                         worker.blocking_time)
-
-        # Another request will return the identical object
-        self.assertIs(worker, script._get_worker('id'))
-
-        # And the stop event will stop the thread
-        script.stop_and_join()
-
-    def test__full_url(self):
-        script = NoActionScript()
-        self.assertEqual('http://localhost:8080/path',
-                         script._full_url('/path'))
-        self.assertEqual('http://localhost:8080/path/to/foo',
-                         script._full_url('/path/to/foo'))
-        script.base_url = 'http://example.com'
-        self.assertEqual('http://example.com/path/to/foo',
-                         script._full_url('/path/to/foo'))
-        script.base_url = 'http://example.com/base'
-        self.assertEqual('http://example.com/base/path/to/foo',
-                         script._full_url('/path/to/foo'))
-        script.base_url = 'http://example.com'
-        self.assertEqual('http://example.com:8080/path',
-                         script._full_url(':8080/path'))
-
-    def test_single_threaded(self):
-        script = NoActionScript.parse("""{
-            "parameters": {"base_url": ""},
-            "requests": [
-                {"thread": "1", "relpath": "first"},
-                {"thread": "1", "relpath": "second"},
-                {"thread": "1", "relpath": "third"},
-                {"thread": "1", "relpath": "fourth"}
-            ]}""")
-        script.run()
-        worker = script._get_worker("1")
-        self.assertEqual(["first", "second", "third", "fourth"],
-                         [s[0] for s in worker.stats])
-
-    def test_two_threads(self):
-        script = NoActionScript.parse("""{
-            "parameters": {"base_url": ""},
-            "requests": [
-                {"thread": "1", "relpath": "first"},
-                {"thread": "2", "relpath": "second"},
-                {"thread": "1", "relpath": "third"},
-                {"thread": "2", "relpath": "fourth"}
-            ]}""")
-        script.run()
-        worker = script._get_worker("1")
-        self.assertEqual(["first", "third"],
-                         [s[0] for s in worker.stats])
-        worker = script._get_worker("2")
-        self.assertEqual(["second", "fourth"],
-                         [s[0] for s in worker.stats])
-
-
-class TestActionScriptIntegration(tests.TestCaseWithTransport):
-
-    def setUp(self):
-        super(TestActionScriptIntegration, self).setUp()
-        self.transport_readonly_server = http_server.HttpServer
-
-    def test_full_integration(self):
-        self.build_tree(['first', 'second', 'third', 'fourth'])
-        url = self.get_readonly_url()
-        script = load_test.ActionScript.parse("""{
-            "parameters": {"base_url": "%s", "blocking_timeout": 0.1},
-            "requests": [
-                {"thread": "1", "relpath": "first"},
-                {"thread": "2", "relpath": "second"},
-                {"thread": "1", "relpath": "no-this"},
-                {"thread": "2", "relpath": "or-this"},
-                {"thread": "1", "relpath": "third"},
-                {"thread": "2", "relpath": "fourth"}
-            ]}""" % (url,))
-        script.run()
-        worker = script._get_worker("1")
-        self.assertEqual([("first", True), ('no-this', False),
-                          ("third", True)],
-                         [(s[0].rsplit('/', 1)[1], s[1])
-                          for s in worker.stats])
-        worker = script._get_worker("2")
-        self.assertEqual([("second", True), ('or-this', False),
-                          ("fourth", True)],
-                         [(s[0].rsplit('/', 1)[1], s[1])
-                          for s in worker.stats])
-
-
-class TestRunScript(tests.TestCaseWithTransport):
-
-    def setUp(self):
-        super(TestRunScript, self).setUp()
-        self.transport_readonly_server = http_server.HttpServer
-
-    def test_run_script(self):
-        self.build_tree(['file1', 'file2', 'file3', 'file4'])
-        url = self.get_readonly_url()
-        self.build_tree_contents([('localhost.script', """{
-    "parameters": {"base_url": "%s", "blocking_timeout": 0.1},
-    "requests": [
-        {"thread": "1", "relpath": "file1"},
-        {"thread": "2", "relpath": "file2"},
-        {"thread": "1", "relpath": "file3"},
-        {"thread": "2", "relpath": "file4"}
-    ]
-}""" % (url,))])
-        script = load_test.run_script('localhost.script')
-        worker = script._threads["1"][0]
-        self.assertEqual([("file1", True), ('file3', True)],
-                         [(s[0].rsplit('/', 1)[1], s[1])
-                          for s in worker.stats])
-        worker = script._threads["2"][0]
-        self.assertEqual([("file2", True), ("file4", True)],
-                         [(s[0].rsplit('/', 1)[1], s[1])
-                          for s in worker.stats])

=== modified file 'loggerhead/trace.py'
--- loggerhead/trace.py	2010-11-12 00:09:49 +0000
+++ loggerhead/trace.py	2008-10-24 02:26:05 +0000
@@ -22,7 +22,6 @@
 
 import os
 import logging
-import logging.handlers
 import sys
 
 

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2010-04-28 21:41:32 +0000
+++ loggerhead/util.py	2009-11-26 03:44:40 +0000
@@ -36,8 +36,6 @@
 except ImportError:
     from elementtree import ElementTree as ET
 
-from bzrlib import urlutils
-
 from simpletal.simpleTALUtils import HTMLStructureCleaner
 
 log = logging.getLogger("loggerhead.controllers")
@@ -68,7 +66,7 @@
 
 def date_time(value):
     if value is not None:
-        return value.strftime('%Y-%m-%d %H:%M:%S')
+        return value.strftime('%Y-%m-%d %T')
     else:
         return 'N/A'
 
@@ -137,7 +135,6 @@
     """
 
     def __init__(self, _dict=None, **kw):
-        self._properties = {}
         if _dict is not None:
             for key, value in _dict.iteritems():
                 setattr(self, key, value)
@@ -154,24 +151,6 @@
         out += '}'
         return out
 
-    def __getattr__(self, attr):
-        """Used for handling things that aren't already available."""
-        if attr.startswith('_') or attr not in self._properties:
-            raise AttributeError('No attribute: %s' % (attr,))
-        val = self._properties[attr](self, attr)
-        setattr(self, attr, val)
-        return val
-
-    def _set_property(self, attr, prop_func):
-        """Set a function that will be called when an attribute is desired.
-
-        We will cache the return value, so the function call should be
-        idempotent. We will pass 'self' and the 'attr' name when triggered.
-        """
-        if attr.startswith('_'):
-            raise ValueError("Cannot create properties that start with _")
-        self._properties[attr] = prop_func
-
 
 def trunc(text, limit=10):
     if len(text) <= limit:
@@ -345,14 +324,6 @@
     return out
 
 
-def local_path_from_url(url):
-    """Convert Bazaar URL to local path, ignoring readonly+ prefix"""
-    readonly_prefix = 'readonly+'
-    if url.startswith(readonly_prefix):
-        url = url[len(readonly_prefix):]
-    return urlutils.local_path_from_url(url)
-
-
 def fill_in_navigation(navigation):
     """
     given a navigation block (used by the template for the page header), fill

=== modified file 'loggerheadd'
--- loggerheadd	2009-04-30 10:39:05 +0000
+++ loggerheadd	2008-11-24 20:26:26 +0000
@@ -16,9 +16,9 @@
 
 LHUSER=loggerhead
 
-if [ `whoami` = "$LHUSER" ]; then
+if [ `whoami` = "$LHUSER" ]; then                                                                                   
     SUDO=""
-else
+else                                                                                                                
     SUDO="sudo -H -u $LHUSER"
 fi
 

